﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reactive.Linq;
using System.Reactive.Concurrency;
using System.IO;

namespace UsingDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            var ob = Observable.Using<string, StreamReader>
                (() => new StreamReader(new FileStream("..\\..\\Data.txt", FileMode.Open)),
                reader => (from s in reader.ReadToEnd().Split(new char[] {'\n'}) select s)
                    .ToObservable(Scheduler.NewThread).Finally(CleanUp));

            ob.Subscribe(Console.WriteLine,
                e => Console.WriteLine(e.Message),
                () => Console.WriteLine("[Complete]"));
            Console.ReadKey();
        }

        static void CleanUp()
        {
            Console.WriteLine("Cleaning up...");
        }
    }
}
